// Generated, do not edit by hand.

#pragma once

#include <vector>

#include <vcsn/algos/fwd.hh> // letter_class_t
#include <vcsn/dyn/fwd.hh> // dyn::automaton, etc.
#include <vcsn/dyn/name.hh> // integral_constant
#include <vcsn/dyn/types.hh> // identities, etc.
#include <vcsn/misc/export.hh> // LIBVCSN_API
#include <vcsn/misc/fwd.hh> // signature

namespace vcsn
{
  class automaton_editor;
}

namespace vcsn { namespace dyn { namespace detail {

#define REGISTRY_DECLARE(Name, Signature)                       \
  using Name ## _t = auto Signature;                            \
  LIBVCSN_API                                                   \
  bool Name ## _register(const signature& sig, Name ## _t fn)

  // accessible (accessible.hh).
  REGISTRY_DECLARE(accessible,
    (const automaton& aut) -> automaton);

  // add (add.hh).
  REGISTRY_DECLARE(add,
    (const automaton& lhs, const automaton& rhs, const std::string& algo) -> automaton);

  // add_expansion (add.hh).
  REGISTRY_DECLARE(add_expansion,
    (const expansion& lhs, const expansion& rhs) -> expansion);

  // add_expression (add.hh).
  REGISTRY_DECLARE(add_expression,
    (const expression& lhs, const expression& rhs) -> expression);

  // add_polynomial (add.hh).
  REGISTRY_DECLARE(add_polynomial,
    (const polynomial& lhs, const polynomial& rhs) -> polynomial);

  // add_weight (add.hh).
  REGISTRY_DECLARE(add_weight,
    (const weight& lhs, const weight& rhs) -> weight);

  // ambiguous_word (is-ambiguous.hh).
  REGISTRY_DECLARE(ambiguous_word,
    (const automaton& aut) -> label);

  // are_equivalent (are-equivalent.hh).
  REGISTRY_DECLARE(are_equivalent,
    (const automaton& aut1, const automaton& aut2) -> bool);

  // are_equivalent_expression (are-equivalent.hh).
  REGISTRY_DECLARE(are_equivalent_expression,
    (const expression& r1, const expression& r2) -> bool);

  // are_isomorphic (are-isomorphic.hh).
  REGISTRY_DECLARE(are_isomorphic,
    (const automaton& aut1, const automaton& aut2) -> bool);

  // cerny (cerny.hh).
  REGISTRY_DECLARE(cerny,
    (const context& ctx, unsigned num_states) -> automaton);

  // coaccessible (accessible.hh).
  REGISTRY_DECLARE(coaccessible,
    (const automaton& aut) -> automaton);

  // codeterminize (determinize.hh).
  REGISTRY_DECLARE(codeterminize,
    (const automaton& aut, const std::string& algo) -> automaton);

  // cominimize (minimize.hh).
  REGISTRY_DECLARE(cominimize,
    (const automaton& aut, const std::string& algo) -> automaton);

  // complement (complement.hh).
  REGISTRY_DECLARE(complement,
    (const automaton& aut) -> automaton);

  // complement_expansion (complement.hh).
  REGISTRY_DECLARE(complement_expansion,
    (const expansion& xpn) -> expansion);

  // complement_expression (complement.hh).
  REGISTRY_DECLARE(complement_expression,
    (const expression& exp) -> expression);

  // complete (complete.hh).
  REGISTRY_DECLARE(complete,
    (const automaton& aut) -> automaton);

  // component (scc.hh).
  REGISTRY_DECLARE(component,
    (const automaton& aut, unsigned num) -> automaton);

  // compose (compose.hh).
  REGISTRY_DECLARE(compose,
    (const automaton& lhs, const automaton& rhs, bool lazy) -> automaton);

  // compose_expansion (compose-expression.hh).
  REGISTRY_DECLARE(compose_expansion,
    (const expansion& lhs, const expansion& rhs) -> expansion);

  // compose_expression (compose-expression.hh).
  REGISTRY_DECLARE(compose_expression,
    (const expression& lhs, const expression& rhs) -> expression);

  // compose_polynomial (compose-expression.hh).
  REGISTRY_DECLARE(compose_polynomial,
    (const polynomial& lhs, const polynomial& rhs) -> polynomial);

  // concatenate_expression (multiply.hh).
  REGISTRY_DECLARE(concatenate_expression,
    (const expression& lhs, const expression& rhs) -> expression);

  // condense (scc.hh).
  REGISTRY_DECLARE(condense,
    (const automaton& aut) -> automaton);

  // conjugate (conjugate.hh).
  REGISTRY_DECLARE(conjugate,
    (const automaton& a) -> automaton);

  // conjunction (conjunction.hh).
  REGISTRY_DECLARE(conjunction,
    (const std::vector<automaton>& as, bool lazy) -> automaton);

  // conjunction_expansion (conjunction.hh).
  REGISTRY_DECLARE(conjunction_expansion,
    (const expansion& lhs, const expansion& rhs) -> expansion);

  // conjunction_expression (conjunction.hh).
  REGISTRY_DECLARE(conjunction_expression,
    (const expression& lhs, const expression& rhs) -> expression);

  // conjunction_polynomial (conjunction.hh).
  REGISTRY_DECLARE(conjunction_polynomial,
    (const polynomial& lhs, const polynomial& rhs) -> polynomial);

  // conjunction_repeated (conjunction.hh).
  REGISTRY_DECLARE(conjunction_repeated,
    (const automaton& aut, unsigned n) -> automaton);

  // constant_term (constant-term.hh).
  REGISTRY_DECLARE(constant_term,
    (const expression& exp) -> weight);

  // context_of (make-context.hh).
  REGISTRY_DECLARE(context_of,
    (const automaton& aut) -> context);

  // context_of_expansion (make-context.hh).
  REGISTRY_DECLARE(context_of_expansion,
    (const expansion& exp) -> context);

  // context_of_expression (make-context.hh).
  REGISTRY_DECLARE(context_of_expression,
    (const expression& exp) -> context);

  // context_of_polynomial (make-context.hh).
  REGISTRY_DECLARE(context_of_polynomial,
    (const polynomial& poly) -> context);

  // copy (copy.hh).
  REGISTRY_DECLARE(copy,
    (const automaton& aut) -> automaton);

  // copy_convert (copy.hh).
  REGISTRY_DECLARE(copy_convert,
    (const automaton& aut, const context& ctx) -> automaton);

  // copy_expression (copy.hh).
  REGISTRY_DECLARE(copy_expression,
    (const expression& exp, const context& ctx, identities ids) -> expression);

  // costandard (standard.hh).
  REGISTRY_DECLARE(costandard,
    (const automaton& aut) -> automaton);

  // cotrie (trie.hh).
  REGISTRY_DECLARE(cotrie,
    (const polynomial& poly) -> automaton);

  // cotrie_stream (trie.hh).
  REGISTRY_DECLARE(cotrie_stream,
    (const context& ctx, std::istream& is, const std::string& format) -> automaton);

  // de_bruijn (de-bruijn.hh).
  REGISTRY_DECLARE(de_bruijn,
    (const dyn::context& ctx, unsigned n) -> automaton);

  // delay_automaton (is-synchronized.hh).
  REGISTRY_DECLARE(delay_automaton,
    (const automaton& aut) -> automaton);

  // derivation (derivation.hh).
  REGISTRY_DECLARE(derivation,
    (const expression& exp, const label& lbl, bool breaking) -> polynomial);

  // derived_term (derived-term.hh).
  REGISTRY_DECLARE(derived_term,
    (const expression& exp, const std::string& algo) -> automaton);

  // determinize (determinize.hh).
  REGISTRY_DECLARE(determinize,
    (const automaton& aut, const std::string& algo) -> automaton);

  // difference (are-equivalent.hh).
  REGISTRY_DECLARE(difference,
    (const automaton& lhs, const automaton& rhs) -> automaton);

  // difference_expression (are-equivalent.hh).
  REGISTRY_DECLARE(difference_expression,
    (const expression& lhs, const expression& rhs) -> expression);

  // divkbaseb (divkbaseb.hh).
  REGISTRY_DECLARE(divkbaseb,
    (const context& ctx, unsigned divisor, unsigned base) -> automaton);

  // double_ring (double-ring.hh).
  REGISTRY_DECLARE(double_ring,
    (const context& ctx, unsigned n, const std::vector<unsigned>& finals) -> automaton);

  // eliminate_state (to-expression.hh).
  REGISTRY_DECLARE(eliminate_state,
    (const automaton& aut, int state) -> automaton);

  // eval_polynomial (evaluate.hh).
  REGISTRY_DECLARE(eval_polynomial,
    (const automaton& aut, const polynomial& poly) -> weight);

  // evaluate (evaluate.hh).
  REGISTRY_DECLARE(evaluate,
    (const automaton& aut, const label& lbl) -> weight);

  // expand (expand.hh).
  REGISTRY_DECLARE(expand,
    (const expression& exp) -> expression);

  // expression_one (constant.hh).
  REGISTRY_DECLARE(expression_one,
    (const context& ctx, identities ids) -> expression);

  // expression_zero (constant.hh).
  REGISTRY_DECLARE(expression_zero,
    (const context& ctx, identities ids) -> expression);

  // factor (prefix.hh).
  REGISTRY_DECLARE(factor,
    (const automaton& aut) -> automaton);

  // filter (filter.hh).
  REGISTRY_DECLARE(filter,
    (const automaton& aut, const std::vector<unsigned>& states) -> automaton);

  // focus (focus.hh).
  REGISTRY_DECLARE(focus,
    (const automaton& aut, integral_constant) -> automaton);

  // has_bounded_lag (has-bounded-lag.hh).
  REGISTRY_DECLARE(has_bounded_lag,
    (const automaton& aut) -> bool);

  // has_lightening_cycle (has-lightening-cycle.hh).
  REGISTRY_DECLARE(has_lightening_cycle,
    (const automaton& aut) -> bool);

  // has_twins_property (has-twins-property.hh).
  REGISTRY_DECLARE(has_twins_property,
    (const automaton& aut) -> bool);

  // identities_of (identities-of.hh).
  REGISTRY_DECLARE(identities_of,
    (const expression& exp) -> identities);

  // inductive (inductive.hh).
  REGISTRY_DECLARE(inductive,
    (const expression& exp, const std::string& algo) -> automaton);

  // infiltrate (conjunction.hh).
  REGISTRY_DECLARE(infiltrate,
    (const std::vector<automaton>& as) -> automaton);

  // infiltrate_expression (conjunction.hh).
  REGISTRY_DECLARE(infiltrate_expression,
    (const expression& lhs, const expression& rhs) -> expression);

  // info (info.hh).
  REGISTRY_DECLARE(info,
    (const automaton& aut, std::ostream& out, unsigned details) -> std::ostream&);

  // info_expression (info.hh).
  REGISTRY_DECLARE(info_expression,
    (const expression& exp, std::ostream& o) -> std::ostream&);

  // insplit (insplit.hh).
  REGISTRY_DECLARE(insplit,
    (const automaton& aut, bool lazy) -> automaton);

  // is_accessible (accessible.hh).
  REGISTRY_DECLARE(is_accessible,
    (const automaton& aut) -> bool);

  // is_ambiguous (is-ambiguous.hh).
  REGISTRY_DECLARE(is_ambiguous,
    (const automaton& aut) -> bool);

  // is_coaccessible (accessible.hh).
  REGISTRY_DECLARE(is_coaccessible,
    (const automaton& aut) -> bool);

  // is_codeterministic (is-deterministic.hh).
  REGISTRY_DECLARE(is_codeterministic,
    (const automaton& aut) -> bool);

  // is_complete (is-complete.hh).
  REGISTRY_DECLARE(is_complete,
    (const automaton& aut) -> bool);

  // is_costandard (standard.hh).
  REGISTRY_DECLARE(is_costandard,
    (const automaton& aut) -> bool);

  // is_cycle_ambiguous (is-ambiguous.hh).
  REGISTRY_DECLARE(is_cycle_ambiguous,
    (const automaton& aut) -> bool);

  // is_deterministic (is-deterministic.hh).
  REGISTRY_DECLARE(is_deterministic,
    (const automaton& aut) -> bool);

  // is_empty (accessible.hh).
  REGISTRY_DECLARE(is_empty,
    (const automaton& aut) -> bool);

  // is_eps_acyclic (is-acyclic.hh).
  REGISTRY_DECLARE(is_eps_acyclic,
    (const automaton& aut) -> bool);

  // is_functional (is-functional.hh).
  REGISTRY_DECLARE(is_functional,
    (const automaton& aut) -> bool);

  // is_letterized (letterize.hh).
  REGISTRY_DECLARE(is_letterized,
    (const automaton& aut) -> bool);

  // is_normalized (normalize.hh).
  REGISTRY_DECLARE(is_normalized,
    (const automaton& aut) -> bool);

  // is_out_sorted (sort.hh).
  REGISTRY_DECLARE(is_out_sorted,
    (const automaton& aut) -> bool);

  // is_partial_identity (is-partial-identity.hh).
  REGISTRY_DECLARE(is_partial_identity,
    (const automaton& aut) -> bool);

  // is_proper (is-proper.hh).
  REGISTRY_DECLARE(is_proper,
    (const automaton& aut) -> bool);

  // is_realtime (letterize.hh).
  REGISTRY_DECLARE(is_realtime,
    (const automaton& aut) -> bool);

  // is_standard (standard.hh).
  REGISTRY_DECLARE(is_standard,
    (const automaton& aut) -> bool);

  // is_synchronized (is-synchronized.hh).
  REGISTRY_DECLARE(is_synchronized,
    (const automaton& aut) -> bool);

  // is_synchronized_by (synchronizing-word.hh).
  REGISTRY_DECLARE(is_synchronized_by,
    (const automaton& aut, const label& word) -> bool);

  // is_synchronizing (synchronizing-word.hh).
  REGISTRY_DECLARE(is_synchronizing,
    (const automaton& aut) -> bool);

  // is_trim (accessible.hh).
  REGISTRY_DECLARE(is_trim,
    (const automaton& aut) -> bool);

  // is_useless (accessible.hh).
  REGISTRY_DECLARE(is_useless,
    (const automaton& aut) -> bool);

  // is_valid (is-valid.hh).
  REGISTRY_DECLARE(is_valid,
    (const automaton& aut) -> bool);

  // is_valid_expression (is-valid-expression.hh).
  REGISTRY_DECLARE(is_valid_expression,
    (const expression& exp) -> bool);

  // join (make-context.hh).
  REGISTRY_DECLARE(join,
    (const context& c1, const context& c2) -> context);

  // ladybird (ladybird.hh).
  REGISTRY_DECLARE(ladybird,
    (const dyn::context& ctx, unsigned n) -> automaton);

  // ldivide (conjunction.hh).
  REGISTRY_DECLARE(ldivide,
    (const automaton& aut1, const automaton& aut2) -> automaton);

  // ldivide_expansion (divide.hh).
  REGISTRY_DECLARE(ldivide_expansion,
    (const expansion& lhs, const expansion& rhs) -> expansion);

  // ldivide_expression (divide.hh).
  REGISTRY_DECLARE(ldivide_expression,
    (const expression& lhs, const expression& rhs) -> expression);

  // ldivide_label (divide.hh).
  REGISTRY_DECLARE(ldivide_label,
    (const label& lhs, const label& rhs) -> label);

  // ldivide_polynomial (divide.hh).
  REGISTRY_DECLARE(ldivide_polynomial,
    (const polynomial& lhs, const polynomial& rhs) -> polynomial);

  // ldivide_weight (divide.hh).
  REGISTRY_DECLARE(ldivide_weight,
    (const weight& lhs, const weight& rhs) -> weight);

  // less_than_expression (less-than.hh).
  REGISTRY_DECLARE(less_than_expression,
    (const expression& lhs, const expression& rhs) -> bool);

  // letterize (letterize.hh).
  REGISTRY_DECLARE(letterize,
    (const automaton& aut) -> automaton);

  // levenshtein (levenshtein.hh).
  REGISTRY_DECLARE(levenshtein,
    (const dyn::context& ctx) -> automaton);

  // lgcd_polynomial (divide.hh).
  REGISTRY_DECLARE(lgcd_polynomial,
    (const polynomial& lhs, const polynomial& rhs) -> polynomial);

  // lift_automaton (lift.hh).
  REGISTRY_DECLARE(lift_automaton,
    (const automaton& aut, identities ids, integral_constant) -> automaton);

  // lift_expression (lift.hh).
  REGISTRY_DECLARE(lift_expression,
    (const expression& exp) -> expression);

  // lightest (lightest.hh).
  REGISTRY_DECLARE(lightest,
    (const automaton& aut, unsigned num, const std::string& algo) -> polynomial);

  // lightest_automaton (lightest-automaton.hh).
  REGISTRY_DECLARE(lightest_automaton,
    (const automaton& aut, unsigned k, const std::string& algo) -> automaton);

  // list_polynomial (print.hh).
  REGISTRY_DECLARE(list_polynomial,
    (const polynomial& polynomial, std::ostream& o) -> std::ostream&);

  // lweight (weight.hh).
  REGISTRY_DECLARE(lweight,
    (const weight& weight, const automaton& aut, const std::string& algo) -> automaton);

  // lweight_expansion (weight.hh).
  REGISTRY_DECLARE(lweight_expansion,
    (const weight& weight, const expansion& exp) -> expansion);

  // lweight_expression (weight.hh).
  REGISTRY_DECLARE(lweight_expression,
    (const weight& weight, const expression& exp) -> expression);

  // lweight_polynomial (weight.hh).
  REGISTRY_DECLARE(lweight_polynomial,
    (const weight& weight, const polynomial& poly) -> polynomial);

  // make_automaton_editor (edit-automaton.hh).
  REGISTRY_DECLARE(make_automaton_editor,
    (const context& ctx) -> automaton_editor*);

  // make_context (make-context.hh).
  REGISTRY_DECLARE(make_context,
    (const std::string& name) -> context);

  // make_word_context (make-context.hh).
  REGISTRY_DECLARE(make_word_context,
    (const context& ctx) -> context);

  // minimize (minimize.hh).
  REGISTRY_DECLARE(minimize,
    (const automaton& aut, const std::string& algo) -> automaton);

  // multiply (multiply.hh).
  REGISTRY_DECLARE(multiply,
    (const automaton& lhs, const automaton& rhs, const std::string& algo) -> automaton);

  // multiply_expression (multiply.hh).
  REGISTRY_DECLARE(multiply_expression,
    (const expression& lhs, const expression& rhs) -> expression);

  // multiply_expression_repeated (multiply.hh).
  REGISTRY_DECLARE(multiply_expression_repeated,
    (const expression& re, int min, int max) -> expression);

  // multiply_label (multiply.hh).
  REGISTRY_DECLARE(multiply_label,
    (const label& lhs, const label& rhs) -> label);

  // multiply_label_repeated (multiply.hh).
  REGISTRY_DECLARE(multiply_label_repeated,
    (const label& re, int exp) -> label);

  // multiply_polynomial (multiply.hh).
  REGISTRY_DECLARE(multiply_polynomial,
    (const polynomial& lhs, const polynomial& rhs) -> polynomial);

  // multiply_repeated (multiply.hh).
  REGISTRY_DECLARE(multiply_repeated,
    (const automaton& a, int min, int max, const std::string& algo) -> automaton);

  // multiply_weight (multiply.hh).
  REGISTRY_DECLARE(multiply_weight,
    (const weight& lhs, const weight& rhs) -> weight);

  // multiply_weight_repeated (multiply.hh).
  REGISTRY_DECLARE(multiply_weight_repeated,
    (const weight& wgt, int min, int max) -> weight);

  // normalize (normalize.hh).
  REGISTRY_DECLARE(normalize,
    (const automaton& aut) -> automaton);

  // num_components (scc.hh).
  REGISTRY_DECLARE(num_components,
    (const automaton& aut) -> std::size_t);

  // num_tapes (make-context.hh).
  REGISTRY_DECLARE(num_tapes,
    (const context& ctx) -> size_t);

  // pair (pair.hh).
  REGISTRY_DECLARE(pair,
    (const automaton& aut, bool keep_initials) -> automaton);

  // partial_identity (partial-identity.hh).
  REGISTRY_DECLARE(partial_identity,
    (const automaton& aut) -> automaton);

  // partial_identity_expression (partial-identity-expression.hh).
  REGISTRY_DECLARE(partial_identity_expression,
    (const expression& exp) -> expression);

  // prefix (prefix.hh).
  REGISTRY_DECLARE(prefix,
    (const automaton& aut) -> automaton);

  // print (print.hh).
  REGISTRY_DECLARE(print,
    (const automaton& aut, std::ostream& o, const std::string& fmt) -> std::ostream&);

  // print_context (print.hh).
  REGISTRY_DECLARE(print_context,
    (const context& ctx, std::ostream& o, const std::string& fmt) -> std::ostream&);

  // print_expansion (print.hh).
  REGISTRY_DECLARE(print_expansion,
    (const expansion& expansion, std::ostream& o, const std::string& fmt) -> std::ostream&);

  // print_expression (print.hh).
  REGISTRY_DECLARE(print_expression,
    (const expression& exp, std::ostream& o, const std::string& fmt) -> std::ostream&);

  // print_label (print.hh).
  REGISTRY_DECLARE(print_label,
    (const label& label, std::ostream& o, const std::string& fmt) -> std::ostream&);

  // print_polynomial (print.hh).
  REGISTRY_DECLARE(print_polynomial,
    (const polynomial& polynomial, std::ostream& o, const std::string& fmt) -> std::ostream&);

  // print_weight (print.hh).
  REGISTRY_DECLARE(print_weight,
    (const weight& weight, std::ostream& o, const std::string& fmt) -> std::ostream&);

  // project (project-automaton.hh).
  REGISTRY_DECLARE(project,
    (const automaton& aut, integral_constant) -> automaton);

  // project_context (project.hh).
  REGISTRY_DECLARE(project_context,
    (const context& ctx, integral_constant) -> context);

  // project_expansion (project.hh).
  REGISTRY_DECLARE(project_expansion,
    (const expansion& exp, integral_constant) -> expansion);

  // project_expression (project.hh).
  REGISTRY_DECLARE(project_expression,
    (const expression& exp, integral_constant) -> expression);

  // project_label (project.hh).
  REGISTRY_DECLARE(project_label,
    (const label& lbl, integral_constant) -> label);

  // project_polynomial (project.hh).
  REGISTRY_DECLARE(project_polynomial,
    (const polynomial& poly, integral_constant) -> polynomial);

  // proper (proper.hh).
  REGISTRY_DECLARE(proper,
    (const automaton& aut, direction dir, bool prune, const std::string& algo) -> automaton);

  // push_weights (push-weights.hh).
  REGISTRY_DECLARE(push_weights,
    (const automaton& aut) -> automaton);

  // quotkbaseb (quotkbaseb.hh).
  REGISTRY_DECLARE(quotkbaseb,
    (const context& ctx, unsigned divisor, unsigned base) -> automaton);

  // random_automaton (random-automaton.hh).
  REGISTRY_DECLARE(random_automaton,
    (const context& ctx, unsigned num_states, float density, unsigned num_initial, unsigned num_final, boost::optional<unsigned> max_labels, float loop_chance, const std::string& weights) -> automaton);

  // random_automaton_deterministic (random-automaton.hh).
  REGISTRY_DECLARE(random_automaton_deterministic,
    (const context& ctx, unsigned num_states) -> automaton);

  // random_expression (random-expression.hh).
  REGISTRY_DECLARE(random_expression,
    (const context& ctx, const std::string& param, identities ids) -> expression);

  // random_weight (random-weight.hh).
  REGISTRY_DECLARE(random_weight,
    (const context& ctx, const std::string& param) -> weight);

  // rdivide (conjunction.hh).
  REGISTRY_DECLARE(rdivide,
    (const automaton& aut1, const automaton& aut2) -> automaton);

  // rdivide_expression (divide.hh).
  REGISTRY_DECLARE(rdivide_expression,
    (const expression& lhs, const expression& rhs) -> expression);

  // rdivide_label (divide.hh).
  REGISTRY_DECLARE(rdivide_label,
    (const label& lhs, const label& rhs) -> label);

  // rdivide_weight (divide.hh).
  REGISTRY_DECLARE(rdivide_weight,
    (const weight& lhs, const weight& rhs) -> weight);

  // read_label (read.hh).
  REGISTRY_DECLARE(read_label,
    (const context& ctx, std::istream& is, bool quoted) -> label);

  // read_polynomial (read.hh).
  REGISTRY_DECLARE(read_polynomial,
    (const context& ctx, std::istream& is) -> polynomial);

  // read_weight (read.hh).
  REGISTRY_DECLARE(read_weight,
    (const context& ctx, std::istream& is) -> weight);

  // realtime (letterize.hh).
  REGISTRY_DECLARE(realtime,
    (const automaton& aut) -> automaton);

  // reduce (reduce.hh).
  REGISTRY_DECLARE(reduce,
    (const automaton& aut) -> automaton);

  // rweight (weight.hh).
  REGISTRY_DECLARE(rweight,
    (const automaton& aut, const weight& weight, const std::string& algo) -> automaton);

  // rweight_expansion (weight.hh).
  REGISTRY_DECLARE(rweight_expansion,
    (const expansion& exp, const weight& weight) -> expansion);

  // rweight_expression (weight.hh).
  REGISTRY_DECLARE(rweight_expression,
    (const expression& exp, const weight& weight) -> expression);

  // rweight_polynomial (weight.hh).
  REGISTRY_DECLARE(rweight_polynomial,
    (const polynomial& poly, const weight& weight) -> polynomial);

  // scc (scc.hh).
  REGISTRY_DECLARE(scc,
    (const automaton& aut, const std::string& algo) -> automaton);

  // shortest (shortest.hh).
  REGISTRY_DECLARE(shortest,
    (const automaton& aut, boost::optional<unsigned> num, boost::optional<unsigned> len) -> polynomial);

  // shuffle (conjunction.hh).
  REGISTRY_DECLARE(shuffle,
    (const std::vector<automaton>& as) -> automaton);

  // shuffle_expression (conjunction.hh).
  REGISTRY_DECLARE(shuffle_expression,
    (const expression& lhs, const expression& rhs) -> expression);

  // sort (sort.hh).
  REGISTRY_DECLARE(sort,
    (const automaton& aut) -> automaton);

  // split (split.hh).
  REGISTRY_DECLARE(split,
    (const expression& exp) -> polynomial);

  // split_polynomial (split.hh).
  REGISTRY_DECLARE(split_polynomial,
    (const polynomial& poly) -> polynomial);

  // standard (standard.hh).
  REGISTRY_DECLARE(standard,
    (const automaton& aut) -> automaton);

  // standard_expression (standard.hh).
  REGISTRY_DECLARE(standard_expression,
    (const expression& exp) -> automaton);

  // star (star.hh).
  REGISTRY_DECLARE(star,
    (const automaton& a, const std::string& algo) -> automaton);

  // star_height (star-height.hh).
  REGISTRY_DECLARE(star_height,
    (const expression& exp) -> unsigned);

  // star_normal_form (star-normal-form.hh).
  REGISTRY_DECLARE(star_normal_form,
    (const expression& exp) -> expression);

  // strip (strip.hh).
  REGISTRY_DECLARE(strip,
    (const automaton& aut) -> automaton);

  // subword (prefix.hh).
  REGISTRY_DECLARE(subword,
    (const automaton& aut) -> automaton);

  // suffix (prefix.hh).
  REGISTRY_DECLARE(suffix,
    (const automaton& aut) -> automaton);

  // synchronize (synchronize.hh).
  REGISTRY_DECLARE(synchronize,
    (const automaton& aut) -> automaton);

  // synchronizing_word (synchronizing-word.hh).
  REGISTRY_DECLARE(synchronizing_word,
    (const automaton& aut, const std::string& algo) -> label);

  // thompson (thompson.hh).
  REGISTRY_DECLARE(thompson,
    (const expression& exp) -> automaton);

  // to_expansion (to-expansion.hh).
  REGISTRY_DECLARE(to_expansion,
    (const expression& exp) -> expansion);

  // to_expression (to-expression.hh).
  REGISTRY_DECLARE(to_expression,
    (const automaton& aut, identities ids, const std::string& algo) -> expression);

  // to_expression_class (to-expression.hh).
  REGISTRY_DECLARE(to_expression_class,
    (const context& ctx, identities ids, const letter_class_t& letters, bool accept) -> expression);

  // to_expression_label (to-expression.hh).
  REGISTRY_DECLARE(to_expression_label,
    (const context& ctx, identities ids, const label& lbl) -> expression);

  // transpose (transpose.hh).
  REGISTRY_DECLARE(transpose,
    (automaton& aut) -> automaton);

  // transpose_expression (transpose.hh).
  REGISTRY_DECLARE(transpose_expression,
    (const expression& exp) -> expression);

  // transposition_expression (transpose.hh).
  REGISTRY_DECLARE(transposition_expression,
    (const expression& exp) -> expression);

  // trie (trie.hh).
  REGISTRY_DECLARE(trie,
    (const polynomial& poly) -> automaton);

  // trie_stream (trie.hh).
  REGISTRY_DECLARE(trie_stream,
    (const context& ctx, std::istream& is, const std::string& format) -> automaton);

  // trim (accessible.hh).
  REGISTRY_DECLARE(trim,
    (const automaton& aut) -> automaton);

  // tuple (tuple-automaton.hh).
  REGISTRY_DECLARE(tuple,
    (const std::vector<automaton>& as) -> automaton);

  // tuple_context (tuple.hh).
  REGISTRY_DECLARE(tuple_context,
    (const std::vector<context>& cs) -> context);

  // tuple_expansion (tuple.hh).
  REGISTRY_DECLARE(tuple_expansion,
    (const std::vector<expansion>& es) -> expansion);

  // tuple_expression (tuple.hh).
  REGISTRY_DECLARE(tuple_expression,
    (const std::vector<expression>& es) -> expression);

  // tuple_polynomial (tuple.hh).
  REGISTRY_DECLARE(tuple_polynomial,
    (const std::vector<polynomial>& ps) -> polynomial);

  // u (u.hh).
  REGISTRY_DECLARE(u,
    (const context& ctx, unsigned n) -> automaton);

  // universal (universal.hh).
  REGISTRY_DECLARE(universal,
    (const automaton& aut) -> automaton);

  // weight_one (constant.hh).
  REGISTRY_DECLARE(weight_one,
    (const context& ctx) -> weight);

  // weight_series (weight-series.hh).
  REGISTRY_DECLARE(weight_series,
    (const automaton& aut) -> weight);

  // weight_zero (constant.hh).
  REGISTRY_DECLARE(weight_zero,
    (const context& ctx) -> weight);

  // zpc (zpc.hh).
  REGISTRY_DECLARE(zpc,
    (const expression& exp, const std::string& algo) -> automaton);


#undef REGISTRY_DECLARE
}}}
