import os

def env(key, default):
    res = os.environ[key] if key in os.environ else default
    res = res.strip()
    return res

def integer(key):
    if key in os.environ:
        try:
            val = int(os.environ[key])
        except ValueError:
            val = 1
    else:
        val = 0
    return val

config = {
    'version': '2.4',

    'python':   env('VCSN_PYTHON',   r'''/usr/bin/python3'''),
    'ipython':  env('VCSN_IPYTHON',  r'''no'''),

    'ccache':   env('VCSN_CCACHE',   r'''ccache'''),
    'cppflags': env('VCSN_CPPFLAGS', r'''-D_FORTIFY_SOURCE=2 -I/usr/include '''),
    'cxx':      env('VCSN_CXX',      r'''g++'''),
    'cxxflags': env('VCSN_CXXFLAGS', r'''-g -O2 -fstack-protector-strong -Wformat -Werror=format-security -std=c++14'''),
    'ldflags':  env('VCSN_LDFLAGS',  r'''-Wl,-z,relro -L/usr/lib/x86_64-linux-gnu/vcsn -lrt -pthread  -lboost_filesystem  -lboost_system  '''),

    # Where out files are installed.
    'datadir':    env('VCSN_DATA_PATH',  r'''/usr/share/vcsn'''),
    'includedir': env('VCSN_INCLUDEDIR', r'''/usr/include'''),
    'libdir':     env('VCSN_LIBDIR',     r'''/usr/lib/x86_64-linux-gnu/vcsn'''),
    'pyexecdir':  env('VCSN_PYEXECDIR',  r'''/usr/lib/python3.4/site-packages'''),

    # Various flags.
    'verbose':  integer('VCSN_VERBOSE'),
}
